local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

-- Implement a dummy TTD function if we do not get one from another module
if type(s.TimeToDie) ~= 'function'  then
	a.print(L["No TimeToDie function found, using a dummy function. Consider installing Pusikas' Spellflash: TTD."])
	s.TimeToDie = function(unit)
		return 10
	end
end

a.getHastedTickTime = function(UnhastedTickTime)
	return (UnhastedTickTime / (1 + (UnitSpellHaste("player") / 100)))
end

a.getTotalTicks = function(UnhastedTicks)
	return math.floor(UnhastedTicks * (1 + (UnitSpellHaste("player") / 100)) + 0.5)
end

local name, active, exists
local index
a.PetAssistActive = function()
    index = 10
    repeat
        name,_,_,_,active,_,_,exists = GetPetActionInfo(index)
        index = index - 1
        if name == "PET_MODE_ASSIST" then
			return active
        end
    until not exists
    return false
end

local BloodlustSpells = {
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
}
a.Bloodlust = function()
	return s.Buff(BloodlustSpells, "player")
end

a.MySelf = UnitGUID("player")
a.DoTs = {}

local LastAoETimestamp = 0
local CurrentTimestamp = 0
local LastAoETargetsHit = 0
local event, sourceGUID, destGUID, spellId
local DamagingAoESpells = {
	[104232--[[Rain of Fire]]] = true,
	[104233--[[Rain of Fire]]] = true,
}
local DamageOverTimeSpells = {
	[172--[[Corruption]]] = 6,
	[348--[[Immolate]]] = 3,
	[603--[[Doom]]] = 6,
	[980--[[Agony]]] = 6,
	[30108--[[Unstable Affliction]]] = 6,
	[48181--[[Haunt]]] = 6,
}

a.COMBAT_LOG_EVENT_UNFILTERED = function (event, ...)
	CurrentTimestamp, event, _, sourceGUID, _, _, _, destGUID, _, _, _, spellId = ...
	if sourceGUID == a.MySelf and destGUID ~= a.MySelf and (event == "SPELL_DAMAGE" or event == "SPELL_MISSED" or event =="SPELL_AURA_APPLIED") and DamagingAoESpells[spellId] then
		if CurrentTimestamp == LastAoETimestamp then
			LastAoETargetsHit = LastAoETargetsHit + 1
		else
			LastAoETargetsHit = 1
			LastAoETimestamp = CurrentTimestamp
		end
	end
	if sourceGUID == a.MySelf and destGUID ~= a.MySelf and (event =="SPELL_AURA_APPLIED" or event =="SPELL_AURA_REFRESH") and DamageOverTimeSpells[spellId] then
		if not a.DoTs[destGUID] then
			a.DoTs[destGUID] = {}
		end
		if not a.DoTs[destGUID][spellId] then
			a.DoTs[destGUID][spellId] = {}
		end
		a.DoTs[destGUID][spellId]["crit_pct"] = GetSpellCritChance(DamageOverTimeSpells[spellId])
		a.DoTs[destGUID][spellId]["spell_power"] = GetSpellBonusDamage(DamageOverTimeSpells[spellId])
	elseif sourceGUID == a.MySelf and destGUID ~= a.MySelf and event =="SPELL_AURA_REMOVED" and DamageOverTimeSpells[spellId] and a.DoTs[destGUID] and a.DoTs[destGUID][spellId] then
		a.DoTs[destGUID][spellId] = nil
	end
end

a.stopDoTs = function()
	wipe(a.DoTs)
end

-- register events
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_ENABLED", a.stopDoTs)
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)

-- Check if we are in AoE mode
a.getNumEnemies = function()
	if CurrentTimestamp < LastAoETimestamp + 3 then
		return LastAoETargetsHit
	else
		return 0
	end
end

-- Check if we are in AoE mode
a.getDoTStat = function(spellId, stat)
	if not a.DoTs[UnitGUID("target")] then
		return 0
	elseif not a.DoTs[UnitGUID("target")][spellId] then
		return 0
	end
	return a.DoTs[UnitGUID("target")][spellId][stat]
end


local IntProcs = {
	138898--[[Breath of Many Minds]],
}
local StackingIntProcs = {
	138788--[[Electrified]],
}
-- Check if we got an INT proc
a.getIntProc = function()
	if s.Buff(IntProcs, "player") then
		return s.BuffDuration(IntProcs, "player")
	else
		return 0
	end
end

a.getIntProcStacks = function()
	if s.Buff(StackingIntProcs, "player") then
		return s.BuffStack(StackingIntProcs, "player")
	else
		return 0
	end
end