local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.InCombat = s.InCombat()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.GCD = s.GlobalCooldown()
	x.IntProc = a.getIntProc()
	x.IntProcStack = a.getIntProcStacks()
	local spec = s.Spec()
	a.Flash("Dark Intent")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Banish")
	a.Flash("Create Healthstone", "Create Soulwell")
	a.Flash("Soulshatter")
	a.Flash("Dark Regeneration")
	a.Flash("Burning Rush")
	a.FlashAll("Flask of the Warm Sun", "Mogu Fish Stew", "Prepot")
--	a.Flash("Unbound Will")
	if spec == 1 then
		-- Affliction
		x.TickSpeed = a.getHastedTickTime(2)
		x.UATicks = a.getTotalTicks(7)
		x.UADuration = s.MyDebuffDuration(30108--[[Unstable Affliction]], "target")
		x.UATicksRemain = ceil(x.UADuration / x.TickSpeed)
		x.CorruptionTicks = a.getTotalTicks(9)
		x.CorruptionDuration = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.CorruptionTicksRemain = ceil(x.CorruptionDuration / x.TickSpeed)
		x.AgonyTicks = a.getTotalTicks(12)
		x.AgonyDuration = s.MyDebuffDuration(980--[[Agony]], "target")
		x.AgonyTicksRemain = ceil(x.AgonyDuration / x.TickSpeed)
		x.Metamorphosis = false
		x.DarkSoulCD = s.SpellCooldown(113860--[[Dark Soul: Misery]])
		x.DarkSoulRemains = s.BuffDuration(113860--[[Dark Soul: Misery]], "player")
		x.SoulShards = s.Power("player", SPELL_POWER_SOUL_SHARDS)
		x.MaxGCD = a.getHastedTickTime(1.5)
		x.InterruptMaleficGrasp =  not s.Channeling(103103--[[Malefic Grasp]], "player") or x.DarkSoulCD < x.GCD or s.HealthPercent("target") <= 20
		a.Flash("Summon Felhunter ooc", "Grimoire of Sacrifice")
		a.Flash("Curse of Exhaustion")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Lifeblood",
				"Berserking",
				"Blood Fury",
		        "Dark Soul: Misery",
				"Grimoire: Felhunter",
				"Summon Doomguard", "Summon Terrorguard",
				"Soul Swap with Soulburn",
				"Soulburn w/ Dark Soul or Trinket proc",
				"Soulburn under 20%",
				"Haunt under 20%",
				"Soulburn under 20% w/ procs",
				"Life Tap w/o buffs under 20%",
				"Drain Soul",
				"Life Tap under 20%",
				"Agony when running out",
				"Haunt",
				"Corruption when running out",
				"Unstable Affliction when running out",
				"Agony",
				"Corruption",
				"Unstable Affliction",
				"Agony w/ procs",
				"Corruption w/ procs",
				"Unstable Affliction w/ procs",
				"Life Tap w/o buffs",
				"Malefic Grasp",
				"Life Tap while moving if mana < 80%",
				"Fel Flame while moving",
				"Life Tap")
	elseif spec == 2 then
		-- Demonology
		x.CorruptionSpeed = a.getHastedTickTime(2)
		x.CorruptionTicks = a.getTotalTicks(9)
		x.CorruptionDuration = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.CorruptionTicksRemain = ceil(x.CorruptionDuration / x.CorruptionSpeed)
		x.DoomTicks = a.getTotalTicks(4)
		x.DoomDuration = s.MyDebuffDuration(603--[[Doom]], "target")
		x.DoomTicksRemain = ceil(x.DoomDuration / a.getHastedTickTime(15))
		x.ShadowBoltCastTime = s.CastTime(686--[[Shadow Bolt]])
		x.CorruptionRemaining = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.Metamorphosis = s.Buff(103958--[[Metamorphosis]], "player")
		x.DemonicFury = s.Power("player", SPELL_POWER_DEMONIC_FURY)
		x.DarkSoulRemains = s.BuffDuration(113861--[[Dark Soul: Knowledge]], "player")
		x.SoulFireCondition = x.DarkSoulRemains < x.ShadowBoltCastTime or x.DarkSoulRemains > s.CastTime(6353--[[Soul Fire]])
		x.PerfectAimDuration = s.BuffDuration(138963--[[Perfect Aim]], "player")
		a.Flash("Summon Felguard ooc", "Grimoire of Sacrifice")
		a.Flash("Carrion Swarm")
		a.Flash("Demonic Leap")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Lifeblood",
				"Berserking",
				"Blood Fury",
				"Imp Swarm",
		        "Dark Soul: Knowledge",
				"Grimoire: Felguard",
				"Felstorm", "Wrathstorm",
				"Summon Doomguard", "Summon Terrorguard",
--				"Metamorphosis w/ Perfect Aim and 2+ enemies",
				"Doom w/ Perfect Aim",
				"Touch of Chaos if Corruption < 1.5sec",
				"Soul Fire w/ Perfect Aim",
				"Doom",
				"Touch of Chaos if Corruption < 20sec",
				"Cancel Metamorphosis",
				"Soul Fire in Metamorphosis",
				"Touch of Chaos",
				"Corruption (Demo) w/ Perfect Aim",
				"Hand of Gul'dan w/ Perfect Aim",
				"Corruption (Demo)",
				"Metamorphosis",
				"Hand of Gul'dan",
				"Soul Fire",
				"Life Tap if mana < 60%",
				"Shadow Bolt",
				"Fel Flame while moving")
	elseif spec == 3 then
		-- Destruction
		x.DarkSoulRemains = s.BuffDuration(113858--[[Dark Soul: Instability]], "player")
		x.BurningEmbers = UnitPower("player", SPELL_POWER_BURNING_EMBERS, true) / 10
		x.ImmolateSpeed = a.getHastedTickTime(3)
		x.ImmolateTicks = a.getTotalTicks(5)
		x.ImmolateDuration = s.MyDebuffDuration(348--[[Immolate]], "target")
		x.ImmolateTicksRemain = ceil(x.ImmolateDuration / x.ImmolateSpeed)
		x.Metamorphosis = false
		x.Enemies = a.getNumEnemies()
		if x.Enemies < 1 then
			x.Enemies = 1
		end
		a.Flash("Summon Felhunter ooc", "Grimoire of Sacrifice")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Lifeblood",
				"Berserking",
				"Blood Fury",
		        "Dark Soul: Instability",
				"Grimoire: Felhunter",
				"Summon Doomguard", "Summon Terrorguard",
				"Rain of Fire w/ 2+ enemies",
				"Havoc",
				"Shadowburn",
				"Immolate w/ Perfect Aim",
				"Immolate w/ Dark Soul",
--				"Immolate w/ Int Proc",
				"Chaos Bolt",
				"Chaos Bolt w/ 3 stacks Havoc",
				"Immolate",
				"Conflagrate w/ 2 charges",
				"Rain of Fire",
				"Conflagrate",
				"Incinerate")
	end
end)

